// Add an event listener to the window
window.addEventListener("mousemove", tbMouseMoveListener, false);

var myTimeout;
var triggered = false;

// ==================================
//  function tbMouseMoveListener(event)
// ==================================
// Triggered on mousemove
function tbMouseMoveListener(event)
{
	// If auto hide is enabled
	if (getPrefValue("pref_autoHide","bool"))
	{
		e = event;
		tbBox = gBrowser.tabContainer.boxObject;
		prefHideDelay = getPrefValue("pref_hideDelay","int");
		
		// If hidden AND in the TB's area
		if (hidden() && !posOut())
		{
			// Show the TB
			toggleBar();
		}
		
		// If shown AND out of the TB's area AND a delayed toggle is not triggered
		if (!hidden() && posOut() && !triggered)
		{
			// Trigger a delayed TB toggling
			myTimeout = window.setTimeout(toggleBar,prefHideDelay);
			triggered = true;
		}
		
		// If shown AND in the TB's area AND a delayed toggle is triggered
		if (!hidden() && !posOut() && triggered)
		{
			// Cancel the delayed toggle
			window.clearTimeout(myTimeout);
			triggered = false;
		}
	}
}

// ==================================
//  function hidden()
// ==================================
// Checks if the tabbar is hidden or not
function hidden()
{
	return (gBrowser.mPrefs.getBoolPref("browser.tabs.forceHide"));
}

// ==================================
//  function posOut()
// ==================================
// Checks if the mouse is below the TB
function posOut()
{
	// If the mouse is below the TB
	if (e.screenY > tbBox.screenY + tbBox.height)
	{
		return (true);
	}
	
	return (false);
}

// ==================================
//  function toggleBar()
// ==================================
// This will toggle the tab bar.
function toggleBar()
{
	var menuitem = document.getElementById("toggle_tabbar");
	
	// If the TB is shown
	if (!hidden())
	{
		// Hide the TB
		gBrowser.setStripVisibilityTo(false);
		gBrowser.mPrefs.setBoolPref("browser.tabs.forceHide", true);
		
		// Cancel the delayed toggle
		window.clearTimeout(myTimeout);
		triggered = false;
		
		menuitem.setAttribute("checked", "false");
	}
	
	// If the TB is hidden
	else
	{
		// Show the TB
		gBrowser.setStripVisibilityTo(true);
		gBrowser.mPrefs.setBoolPref("browser.tabs.forceHide", false);
		
		menuitem.setAttribute("checked", "true");
	}
}

/*
function tbSetStatusText(str) {
	var statusTextFld = document.getElementById("statusbar-display");
        statusTextFld.label = str;
}
		tbMousePos = tbBox.screenY + " | " + e.screenX + "," + e.screenY + " | " + e.clientX + "," + e.clientY;
		tbSetStatusText(tbMousePos);

*/